<?php
// Exit if accessed directly
if(! defined('ABSPATH')){
    exit;
}

add_action( 'admin_footer', 'plgysg_big_dashboard_widget' );

function plgysg_big_dashboard_widget() 
{
	if ( get_current_screen()->base !== 'dashboard' ) {
		return;
	}
	?>

	<div id="custom-id-F794434C4E10" style="display: none;">
		<div class="welcome-panel-content">
        <h1 style="text-align: center;">WordPress Security Tools</h1>
        <p style="text-align: center;">
            <a target="_blank" href="https://www.siteguarding.com/en/security-dashboard?pgid=5F3" target="_blank"><img src="<?php echo plugins_url('img/b10.png', dirname(__FILE__)); ?>" /></a>&nbsp;
            <a target="_blank" href="https://www.siteguarding.com/en/security-dashboard?pgid=5F3" target="_blank"><img src="<?php echo plugins_url('img/b11.png', dirname(__FILE__)); ?>" /></a>&nbsp;
            <a target="_blank" href="https://www.siteguarding.com/en/security-dashboard?pgid=5F3" target="_blank"><img src="<?php echo plugins_url('img/b12.png', dirname(__FILE__)); ?>" /></a>&nbsp;
            <a target="_blank" href="https://www.siteguarding.com/en/security-dashboard?pgid=5F3" target="_blank"><img src="<?php echo plugins_url('img/b13.png', dirname(__FILE__)); ?>" /></a>&nbsp;
            <a target="_blank" href="https://www.siteguarding.com/en/security-dashboard?pgid=5F3" target="_blank"><img src="<?php echo plugins_url('img/b14.png', dirname(__FILE__)); ?>" /></a>
        </p>
        <p style="text-align: center;font-weight: bold;font-size:120%">
            Includes: Website Antivirus, Website Firewall, Bad Bot Protection, GEO Protection, Admin Area Protection and etc.
        </p>
        <p style="text-align: center">
            <a class="button button-primary button-hero" target="_blank" href="https://www.siteguarding.com/en/security-dashboard?pgid=5F3">Secure Your Website</a>
        </p>
		</div>
	</div>
	<script>
		jQuery(document).ready(function($) {
			$('#welcome-panel').after($('#custom-id-F794434C4E10').show());
		});
	</script>
	
<?php }

function plgysg_register_menu_page(){
	add_menu_page( 
		'Youtube Subtitle Grabber', 'Youtube Subtitle Grabber', 'manage_options', 'ycc', 'plgysg_menu_page', plugins_url( 'img/icon.png', dirname(__FILE__) ), 6 
	); 
}

function plgysg_menu_page()
{
	if (isset($_POST['action']) && check_admin_referer( 'name_dj73h3kke8d' ))
	{
		$categoryId =  trim( sanitize_text_field( $_POST['categoryId']));
		$onlyThumb =  trim( sanitize_text_field( $_POST['onlyThumb']));
		
		update_option('ysg_video_pos', $videoPos);
		update_option('ysg_category_id', $categoryId);
		update_option('ysg_only_thumbnail', $onlyThumb);
		if ($_POST['action'] == 'grab')
		{
				

					$video['title'] = trim( sanitize_text_field( $_POST['ysg_title']) );
					$video['id'] = trim( sanitize_text_field( $_POST['ysg_videoIdc'] ) );
					$video['lang'] = trim( sanitize_text_field( $_POST['ysg_lang'] ) );

					$video_id =  $video['id'];
					$title =  $video['title'];
					$lang =  $video['lang'];

					// get video info from id
					$video_info = ysg_urlGetContents('https://www.youtube.com/get_video_info?&video_id='.$video_id);//
					$video_link = $onlyThumb ? "<img src=\"https://img.youtube.com/vi/$video_id/hqdefault.jpg\">" : "\n\nhttps://www.youtube.com/watch?v=$video_id\n\n";//

					parse_str($video_info, $video_info_array);


					

					if ($lang == 'auto') {
						$cc_link = @json_decode($video_info_array['player_response'])->captions->playerCaptionsTracklistRenderer->captionTracks[0]->baseUrl;
					} else {
						$cc_link = 'https://www.youtube.com/api/timedtext?lang=' . $lang . '&v=' . $video_id;
					}
					$text = ysg_urlGetContents($cc_link);

					$text=preg_replace('/<\?xml version="1.0" encoding="utf-8" \?><transcript>/','',$text);
					$text=preg_replace('/<\/transcript>/','',$text);
					$text = preg_replace('/(<text start=([^>]+)">)/U', '<P>', $text);
					$text=preg_replace('/<\/text>/','</P>',$text);
					
					$text=str_ireplace('</P>',"</P>\n",$text);
					$text = html_entity_decode($text);
					$text = strip_tags($text);
					$text=str_ireplace("\n","<br>",$text);
			
					$contentPost = $text;
					// Initialize the page ID to -1. This indicates no action has been taken.
					$post_id = -1;
			
					// Setup the author, slug, and title for the post
					$current_user = wp_get_current_user();
					$author_id = $current_user->ID;

					$slug = sanitize_title($title);
				   

				   
				// If the page doesn't already exist, then create it
			
					// Set the post ID so that we know the post was created successfully
					$post_id = wp_insert_post(
						array(
							'comment_status'	=>	'closed',
							'ping_status'		=>	'closed',
							'post_author'		=>	$author_id,
							'post_name'	        =>	addslashes($slug),
							'post_title'		=>	addslashes($title),
							'post_status'		=>	'draft',
							'post_type'         =>	'post',
							'post_content'      =>  $contentPost,
							'post_category'      =>  array($categoryId)
						)
					);
			if (is_int($post_id) && $post_id != 0) :
		   ?>
			<div id="message" class="updated notice notice-success is-dismissible">
				<p>The Video ID <?php echo $video_id; ?> parsed. New post saved. <a href="<?php echo get_site_url(); ?>/?p=<?php echo $post_id; ?>" target="_blank">View post</a></p>
				<button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button>
			</div>
		   <?php elseif (is_wp_error( $post_id )) : ?>
			<div id="message" class="updated notice notice-error is-dismissible">
				<p>The Video ID  <?php echo $video_id; ?> is not parsed.<br>
				<?php echo $post_id->get_error_message(); ?>
				<button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button>
			</div>
		   <?php
		   endif;

		}
		if ($_POST['action'] == 'analyze')
		{
				

					$langsFull = array();
					$langs = array();
					$title = trim( sanitize_text_field( $_POST['ysg_title'] ) );
					$videoIdc = trim( sanitize_text_field( $_POST['ysg_videoIdc'] ) );
					
				if ($videoIdc && $title) {
					
					$video_info = ysg_urlGetContents('https://www.youtube.com/get_video_info?&video_id='.$videoIdc);//

					parse_str($video_info, $video_info_array);

					$videoTitle = $video_info_array['title'] ? $video_info_array['title'] : @json_decode($video_info_array['player_response'])->videoDetails->title;
					$cc_link = json_decode($video_info_array['player_response'])->captions->playerCaptionsTracklistRenderer->captionTracks[0]->baseUrl;
				
					if ($cc_link) {
						$langsFull['auto'] = 'Auto';
					} else {
						$list = ysg_urlGetContents('https://www.youtube.com/api/timedtext?v='.$videoIdc.'&type=list');
						
						$xml = @simplexml_load_string($list);
						
						if ($xml->track) {
							foreach ($xml->track as $track) {
								$langsFull[ (string) $track['lang_code']] = (string) $track['lang_translated'];
							}
						}
					}

					if (array_key_exists('en', $langsFull)) {
						$langs['en'] = $langsFull['en'];
					} else {
						$langs[ysg_array_key_first($langsFull)] = $langsFull[ysg_array_key_first($langsFull)];
					}
					
					if ($title != '' && $videoIdc != '' && !empty($langs)) { 
						$video['title'] = $title; 
						$video['id'] = $videoIdc; 
						$video['langs'] = $langs; 
						$video['videoTitle'] = $videoTitle; 
					}
				}

		}
    }
    ?>
	<h1>Youtube Subtitle Grabber</h1>
		<script>

			function copyTitle(id) {
			  var copyText = document.getElementById(id);
			  var wp_title = document.getElementById(id + "_title");
			  wp_title.value = copyText.value;
			}

		</script>
	<h4><b>Please use this <a target="_blank" href="https://www.siteguarding.com/en/buy-service/youtube-subtitle-grabber-id-1329">link to purchase</a> premium version</b></h4>
	<hr>
        <img src="<?php echo plugins_url( 'img/youtube.png', dirname(__FILE__)); ?>"><br />	<br />	

	<form method="post">
	<?php
	wp_nonce_field( 'name_dj73h3kke8d' );
	?>
	<table class="widefat" style="width:60%;">
		<thead>
			<tr>
				<th style="text-align:center;"><b>Post Category</b></th>
				<th style="text-align:center;"><b>Youtube Video/Thumbnail Position</b></th>
				<th style="text-align:center;"><b>Media</b></th>
			</tr>
		</thead>
		<tbody>
			<tr>
				<td style="width:30%;">
					<select name="categoryId" style="width:99%;">
					<?php foreach (get_categories() as $category){
						$catIdOption = (get_option('ysg_category_id')) ? get_option('ysg_category_id') : '';
						$selected = $category->cat_ID == $catIdOption ? 'selected' : '';
						echo "<option value='{$category->cat_ID}' $selected>{$category->cat_name}</option>";
					}?>
					</select>
				</td>
				<td style="width:30%;">
					<select onClick="alert('This feature available only in Premium Version');" name="videoPos" style="width:99%;">
						<option value="0" selected>Do not insert</option>
					</select>
				</td>
				<td style="width:30%;">
					<select name="onlyThumb" style="width:99%;">
					<?php $onlyThumb = (get_option('ysg_only_thumbnail')) ? get_option('ysg_only_thumbnail') : ''; ?>
						<option value="0" <?php if ($onlyThumb == 0) echo 'selected'; ?>>Video</option>
						<option value="1" <?php if ($onlyThumb == 1) echo 'selected'; ?>>Thumbnail</option>
					</select>
				</td>
			</tr>
		</tbody>
	</table>
	<br><br>
	<?php if (isset($_POST['action']) && $_POST['action'] == 'analyze' && !empty($video)) : ?>
	<table class="widefat" style="width:60%;">
		<thead>
			<tr>
				<th style="text-align:center;"><b>WP Post Title</b></th>
				<th style="text-align:center;"><b>YouTube Video Title</b></th>
				<th style="text-align:center;"><b>Language</b></th>
			</tr>
		</thead>
		<tbody>
			<tr class="ysg_line">
				<td style="width:40%;"><input id="<?php echo $video['id']; ?>_title" type="text" name="ysg_title" placeholder="Enter WP Post Title" value="<?php echo $video['title']; ?>" style="width:99%;" /></td>
				<td style="width:35%;"><input id="<?php echo $video['id']; ?>" type="text" name="ysg_videoTitle" onClick="copyTitle('<?php echo $video['id']; ?>')" readonly="readonly"  title="Click to copy" value="<?php echo $video['videoTitle']; ?>" style="cursor:pointer;width:99%;" /><input type="hidden" name="ysg_videoIdc" readonly="readonly" placeholder="Enter YouTube Video ID" value="<?php echo $video['id']; ?>" style="width:99%;" /></td>
				<td style="width:15%;">
					<select onClick="alert('This feature available only in Premium Version');" style="width:99%;" name="ysg_lang">
					<?php foreach ($langs as $langCode => $langName) : ?>
							<option value="<?php echo $langCode; ?>" selected="selected"><?php echo $langName; ?></option>
					<?php endforeach; ?>
					</select>
				</td>
			</tr>
		</tbody>
	</table>
        <input type="hidden" value="grab" name="action">	
	<p class="submit" style="width:60%;"><input type="submit"  class="button button-primary button-large" value="<?php _e('Start Grabbing') ?>" /></p>
	</form>
	<?php else : ?>
	<table class="widefat" style="width:60%;">
		<thead>
			<tr>
				<th style="text-align:center;"><b>WP Post Title</b></th>
				<th></th>
				<th style="text-align:center;"><b>YouTube Video ID</b></th>
			</tr>
		</thead>
		<tbody>
			<tr class="ysg_line">
				<td style="width:60%;"><input type="text" name="ysg_title" placeholder="Enter WP Post Title" value="" style="width:99%;" /></td>
				<td style="width:5%;"></td>
				<td style="width:35%;"><input type="text" name="ysg_videoIdc" placeholder="Enter YouTube Video ID" value="" style="width:99%;" /></td>
			</tr>
		</tbody>
	</table>
        <input type="hidden" value="analyze" name="action">	
	<p class="submit" style="width:60%;"><input type="submit"  class="button button-primary button-large" value="<?php _e('Analyze') ?>" /></p>
	</form>
    <?php  
	endif;
}

function ysg_urlGetContents($url)
{
	if(function_exists('curl_init') && function_exists('curl_setopt') && function_exists('curl_exec') && function_exists('curl_exec')){
		# Use cURL
		$curl = curl_init($url);

		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_HEADER, 0);
		curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($curl, CURLOPT_TIMEOUT, 5);
		if(stripos($url,'https:') !== false){
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
		}

		$content = @curl_exec($curl);
		curl_close($curl);
	}else{
		# Use FGC, because cURL is not supported
		ini_set('default_socket_timeout',5);
		$content = @file_get_contents($url);
	}
	return $content;
}

add_action( 'admin_menu', 'plgysg_register_menu_page' );


function ysg_array_key_first($arr) {
	foreach($arr as $key => $unused) {
		return $key;
	}
	return NULL;
}


?>